//Funciones de manejo de ficheros
/*
function newFile() {
	window.location = "new_file.php";
}
*/

function new_file(path) {
	//alert("new_file: "+path);
	
	var url = "ajax_new.php";
	var parameters = "path="+path;
	
	var ajaxobj = new AjaxEditor();
	ajaxobj.request_synchronous_text(url, parameters);
	
	//Actualizamos el arbol de ficheros
	generate_tree(path_project, project_name);
	
	//Si el fichero se va a sobreescribir
	if (is_open(path)) {
		delete_layer(path);
	}
	
	//Abrimos una pestaña con ese nuevo fichero
	open_file(path);
	
	//Cerramos la ventana
	contentWin.close();
	
	
	//ajaxobj.get_asynchronous_text(url, parameters, display_filetree, arguments[1]);
	//generate_tree(path, project)
}

function up_file() {
	window.location = "open_file.php";
}


function open_file(path) {
	//alert("open_file: "+path);
	if (!is_open(path)) {
		//Abrimos la nueva pestaña
		var id = insert_layer(path);
		//insert_content(path, content_txt);
		insert_content(id, path);
		//insert_content(path);	
	}
}


function is_open(path) {
	var tabs = document.getElementById('tabs').childNodes;
	for (var i=0; i<tabs.length; i++) {
		if (tabs[i].getAttribute('name') == path) {
			return true;
		}
	}
	return false;
}

//Guarda en el servidor el fichero que indica el path
function save_file(path) {
	var content_txt = encodeURIComponent(get_content());
	//alert(content_txt);
	//alert(escape(content_txt));
	
	var url = "ajax_save.php";
	//var parameters = "action=save_file&path="+escape(path)+"&content="+escape(content_txt);
	var parameters = "path="+path+"&content="+content_txt;
	
	var ajaxobj = new AjaxEditor();
	var result = ajaxobj.request_asynchronous_text(url, parameters);
	
	print_result("Save file successfully.");
		
}


function down_act_file() {
	if (num_layers > 0) {
		down_file(path_act);
	}
	else {
		var result = "Please, open a file.";
		print_result(result);
	}
}

function down_file(path) {
	window.location = path;
}

function delete_file(path) {
	//alert("delete_file: "+path);
		
	var r = confirm("Are you sure to delete this file?");
	if (r==true) {
		//Si el fichero esta abierto, lo cerramos
		if (is_open(path)) {
			//Quitamos la pestaña
			delete_layer(path);
		}
		
		//Borramos el fichero del servidor
		var url = "ajax_delete.php";
		var parameters = "path="+path;
		
		var ajaxobj = new AjaxEditor();
		ajaxobj.request_synchronous_text(url, parameters);
		
		//Actualizamos el arbol de ficheros
		generate_tree(path_project, project_name);
	} 
}


function rename_file (path, newpath) {
		//Si el fichero esta abierto, lo renombramos
		if (is_open(path)) {
			//Quitamos la pestaña
			rename_layer(path, newpath);
		}
		
		//Renombramos el fichero en el servidor
		var url = "ajax_rename.php";
		var parameters = "path="+path+"&newpath="+newpath;
		
		var ajaxobj = new AjaxEditor();
		ajaxobj.request_synchronous_text(url, parameters);
		
		//Actualizamos el arbol de ficheros
		generate_tree(path_project, project_name);
		
		//Cerramos la ventana
		contentWin.close();
}

function file_exists(path) {
		//Borramos el fichero del servidor
		var url = "ajax_checkfile.php";
		var parameters = "path="+path;
		
		var ajaxobj = new AjaxEditor();
		var response = ajaxobj.request_synchronous_text(url, parameters);
		if (response == "1") {
			return true;
		}
		else {
			return false;
		}

}


//Funciones para la compilacion y generacion
function compile() {
	if (num_layers != 0) {
		print_result("Compiling. Please wait.");
		
		var content_txt = encodeURIComponent(get_content());
		
		var url = "ajax_compile.php";
		var parameters = "path="+path_project+"&file="+path_act+"&content="+content_txt;
		
		var ajaxobj = new AjaxEditor();
		var result = ajaxobj.request_synchronous_text(url, parameters);
		//alert(result);
	
		//Mostramos la salida en la zona de resultados
		print_result(result);

	}
	else {
		var result = "Please, open a file.";
		print_result(result);
	}
}

function build() {
	print_result("Building. Please wait.");
	
	if (num_layers != 0) {
		var content_txt = encodeURIComponent(get_content());
		var parameters = "path="+path_project+"&file="+path_act+"&content="+content_txt;
	}
	else {
		//var parameters = "path="+path_project+"&file=''&content="+content_txt;
		var parameters = "path="+path_project;
	}
	
	var url = "ajax_build.php";
	var parameters = "path="+path_project+"&file="+path_act+"&content="+content_txt;
	
	var ajaxobj = new AjaxEditor();
	var result = ajaxobj.request_synchronous_text(url, parameters);
	//alert(result);

	//Mostramos la salida en la zona de resultados
	//var node = document.createElement("pre");
	print_result(result);

	//Actualizamos el arbol de ficheros
	generate_tree(path_project, project_name);
}

//Funciones de la barra de herramientas
function indent() {
	//alert("indentar");
	//editor.do_Tab();
	//document.getElementById('editor').contentWindow.document.execCommand("indent", false, null);
}

function outdent() {
	//alert("indentar");
	//document.getElementById('editor').contentWindow.document.execCommand("outdent", false, null);
}

function copy() {
	//document.getElementById('editor').contentWindow.document.execCommand("copy", false, null);
	//document.getElementById('myfile').contentWindow.document.execCommand("copy", false, null);
	var content = document.getElementById('iframe_content_'+id_act);
	
	
	//if (document.getElementById('myfile')) {
	if (content) {
		try {
			//document.execCommand("copy");
			//document.getElementById('myfile').contentWindow.document.execCommand("copy", false, null);
			content.contentWindow.document.execCommand("copy", false, null);
		}
		catch (e) {
			if (navigator.product == "Gecko") {
				if (confirm("Unprivileged scripts cannot access Cut/Copy/Paste programatically " +
					"for security reasons.  Click OK to see a technical note at mozilla.org " +
					"which shows you how to allow a script to access the clipboard."))
				window.open("http://mozilla.org/editor/midasdemo/securityprefs.html");
			}
		}
	}
	
}

function paste() {
	var content = document.getElementById('iframe_content_'+id_act);
	
	//if (document.getElementById('myfile')) {
	if (content) {
		//document.getElementById('myfile').focus();
		content.focus();
		try {
			//document.execCommand("paste");
			//document.getElementById('myfile').contentWindow.document.execCommand("paste", false, null);
			content.contentWindow.document.execCommand("paste", false, null);
		}
		catch (e) {
			if (navigator.product == "Gecko") {
				if (confirm("Unprivileged scripts cannot access Cut/Copy/Paste programatically " +
					"for security reasons.  Click OK to see a technical note at mozilla.org " +
					"which shows you how to allow a script to access the clipboard."))
				window.open("http://mozilla.org/editor/midasdemo/securityprefs.html");
			}
		}
	}
}

function cut() {
	var content = document.getElementById('iframe_content_'+id_act);
	
	//if (document.getElementById('myfile')) {
	if (content) {		
		try {
			//document.execCommand("cut");
			//document.getElementById('myfile').contentWindow.document.execCommand("cut", false, null);
			content.contentWindow.document.execCommand("cut", false, null);
		}
		catch (e) {
			if (navigator.product == "Gecko") {
				if (confirm("Unprivileged scripts cannot access Cut/Copy/Paste programatically " +
					"for security reasons.  Click OK to see a technical note at mozilla.org " +
					"which shows you how to allow a script to access the clipboard."))
				window.open("http://mozilla.org/editor/midasdemo/securityprefs.html");
			}
		}
	}
}

function undo() {
	
	/*
	if (document.getElementById('editor')) {
		editor.do_Undo();
	}
	*/
	var content = document.getElementById('iframe_content_'+id_act);
	
	//if (document.getElementById('myfile_cp')) {
	if (content) {
		try {
			//document.execCommand("undo", false, null);
			content.contentWindow.document.execCommand("undo", false, null);
			//document.getElementById('myfile').contentWindow.document.execCommand("undo", false, null);
		}
		catch (e) {
			alert("This function is not supported on your web browser.");
		}
	}
	
}

function redo() {
	/*
	if (document.getElementById('editor')) {
		editor.do_Redo();
	}
	*/
	var content = document.getElementById('iframe_content_'+id_act);
	
	//if (document.getElementById('myfile_cp')) {
	if (content) {
		try {
			//document.execCommand("redo", false, null);
			content.contentWindow.document.execCommand("redo", false, null);
		}
		catch (e) {
			alert("This function is not supported on your web browser.");
		}
	}
}


function printCode() {
	var content = document.getElementById('iframe_content_'+id_act);
	
	//if (document.getElementById('myfile')) {
	if (content) {
		//Cargamos el documento en el editor
		//editor.setContents(document.getElementById('myfile').value);
		if (navigator.product == "Gecko") {
			//document.getElementById('editor').contentWindow.print();
			document.getElementById('myfile').contentWindow.print();
		}
		else {
			//document.getElementById('editor').contentWindow.document.execCommand("print");
			//document.getElementById('myfile').contentWindow.document.execCommand("print");
			content.contentWindow.document.execCommand("print");
		}
	}
	else {
		document.getElementById('results').value = "Please, open a file";
	}
}

function backup() {
	window.location = "create_backup.php";
}


function help() {
	window.location = "../help/toolbar_help.php";
}


//Funciones auxiliares
function print_result(str) {
		//alert(str);

		//alert(document.getElementById("results").firstChild);
		var node = document.createElement("pre");

		var ua = navigator.userAgent;
		if(ua.match('MSIE')) {
			//Preparamos el string para IE
			str = str.replace(/\n/g, "\n\r");
		}

		node.appendChild(document.createTextNode(str));
		document.getElementById("results").removeChild(document.getElementById("results").firstChild);
		document.getElementById("results").appendChild(node);
		show_result(0);
}

